#include <iostream>
#include <iomanip>

using namespace std;


typedef struct typek {
	char   name[21];
	double amount;
	int index;
	int secIndex;
};

typedef struct blabla {
	int indexKdo;
	int indexOdkud;
	int poradi;
};


int porovnani(const void* a, const void* b) {
	typek * aa, * bb;

	aa = (typek *) a;
	bb = (typek *) b;

	if (aa->amount > bb->amount) {
		return 1;
	} else if (aa->amount == bb->amount) {
		return 0;
	}

	return -1;
}


int seradTypky(const void *a, const void *b) {
	typek *aa, *bb;

	aa = (typek *) a;
	bb = (typek *) b;
cout << "radim";


	if (aa->index < bb->index) {
		return 1;
	} else if (aa->index == bb->index) {
		return 0;
	}

		return -1;
}

int novePorovnani(const void* a, const void *b) {
	blabla *aa, *bb;

	aa = (blabla*) a;
	bb = (blabla*) b;

	if (aa->poradi > bb->poradi) {
		return 1;
	} else if (aa->poradi == bb->poradi) {
		return 0;
	}

	return -1;
}

int serad(const void* a, const void* b) {
	typek *aa, *bb;

	aa = (typek *) a;
	bb = (typek *) b;

	if (aa->index > bb->index) {
		return 1;
	} else if(aa->index == bb->index) {
		return 0;
	}

	return -1;
}

int find(typek* pole, int minIndex, int maxIndex, double number) {
//	int x,y,stred;

	for (int iter = minIndex; iter <= maxIndex; iter++) {
		if (pole[iter].amount >= number) {
			return iter;
		}
	}

	return -1;

	/*cout << minIndex <<"," << maxIndex<< ":" << number << " || ";

	if (number < 0) {
		// pro buyera
		//
		if (number > pole[maxIndex].amount) return -1;
	} else {
		// pro sellera
		if (number > pole[maxIndex].amount) return -1;
	}

	x = minIndex;
	y = maxIndex;

	int ret = -1;

	while (1) {
		stred = (y+x) / 2;

		if (pole[stred].amount >= number) {
			y = stred;
			ret = stred;
		} else {
			
			if (y > x) {
				x += 1;
			}
		}

		if (x == y) return ret;


		if (number > 0) {
			if (y - x == 1) return y;
			if (x - y == 1) return x;
		} else {
			if (y - x == 1) return x;
			if (x - y == 1) return y;
		}

		if (number > 0) {
			if (y - x < 2) return y;
			if (x - y < 2) return x;
		} else {
			if (y - x< 2) return x;
			if (x - y < 2) return y;
		}

	}*/



	return -1;
}


int seradInty(const void* a, const void *b) {
	int aa, bb;

	aa = *((int *) a);
	bb = *((int *) b);
	
	if (aa > bb) {
		return 1;
	} else if (aa == bb) return 0;

	return -1;
}

int main(int argc, char **argv) {
	int count;
	char name[21];
	typek *typci = NULL;

	typek megapole[1000];


	while (1) {
	cin >> count >> name;

	if ((count == 0) && (!strncmp(name, "END", 3))) {
		return 0;
	}

	cout << name << endl;

	typci = new typek[count];

	for (int iter = 0; iter < count; iter++) {
		char oper[5];
		typci[iter].index = iter;

		cin >> typci[iter].name >> oper >> typci[iter].amount;
		
		if (strncmp(oper, "buy", 3)) {
			typci[iter].amount *= -1;
		}
	}

	qsort(typci, count, sizeof(typek), porovnani);

	int indexMin = 0;
	double min = -1.0;
	for (int iter = count - 1; iter > 0; iter--) {

		if (typci[iter].amount >= 0) {
			min      = typci[iter].amount;
			indexMin = iter;
		}
	}

//	cout << indexMin << " | " << min << endl;

	if (min == -1.0 || indexMin == 0) {
		qsort(typci, count, sizeof(typek), serad);


		for (int iter = 0; iter < count; iter++) {
			cout << typci[iter].name << ": NO-ONE" << endl;
		}


		continue;
	}

	int tmpIndex = -1;
	int tmpBuyIndex = -1;
	int sellIndex, buyIndex;


	for (int iter = 0; iter < count; iter++) {
	//	cout << typci[iter].name << " " << typci[iter].amount << " ";
	//	cout.flush();

		if (typci[iter].amount < 0) {
			//seleri
			sellIndex = (tmpIndex == -1 ? count -1 : tmpIndex);
		
	//		cout << indexMin << " <> " << sellIndex << endl;

			typci[iter].secIndex = find(typci, indexMin, sellIndex, typci[iter].amount * (-1));

			if (typci[iter].secIndex != -1) tmpIndex = typci[iter].secIndex;

		} else {
			//buyeri
			buyIndex = (tmpBuyIndex == -1 ? 0 : tmpBuyIndex);

			typci[iter].secIndex = find(typci, buyIndex, indexMin - 1, typci[iter].amount * (-1));

			if (typci[iter].secIndex != -1) tmpBuyIndex = typci[iter].secIndex;
		}


		//cout << typci[iter].name << " " << typci[iter].amount << " " << typci[iter].secIndex << endl;
	}


	blabla *policko;
	policko = new blabla[count];

	for (int iter = 0; iter < count; iter++) {
		policko[iter].indexKdo   = iter;
		policko[iter].indexOdkud = typci[iter].secIndex;
		policko[iter].poradi     = typci[iter].index;
	}

	qsort(policko, count, sizeof(blabla), novePorovnani);

	int iter;
	int j;
	int kamIndex;

//	int *indexy = NULL;

	for (iter = 0; iter < count; iter++) {
		cout << typci[policko[iter].indexKdo].name << ":";

		
		if (policko[iter].indexOdkud == -1) {
			cout << " NO-ONE";
		} else {
			kamIndex = (typci[policko[iter].indexKdo].amount < 0 ? count - 1 : indexMin - 1);

			//cout << policko[iter].indexOdkud << "::" << kamIndex << endl;
			//
			//

			memcpy(megapole, typci + policko[iter].indexOdkud,(kamIndex - policko[iter].indexOdkud + 1) * sizeof(typek));

			qsort(megapole, kamIndex - policko[iter].indexOdkud, sizeof(typek), seradTypky);

			for (j = 0; j <= kamIndex - policko[iter].indexOdkud; j++) {
				cout << " " << megapole[j].name;
			}




//			for (j = policko[iter].indexOdkud; j <= kamIndex; j++) {
//				cout << " " << typci[j].name;
//			}

/*			indexy = new int[kamIndex - policko[iter].indexOdkud + 1];
		
			

			for (j = policko[iter].indexOdkud; j <= kamIndex; j++) {
				indexy[j - policko[iter].indexOdkud] = typci[j].index;
			}
	
			qsort(indexy, kamIndex - policko[iter].indexOdkud + 1, sizeof(int), seradInty);

			for (j = 0; j < kamIndex - policko[iter].indexOdkud + 1; j++) {
				cout << " " << typci[policko[indexy[j]].poradi].name;
			}


			delete [] indexy;*/
		}


		cout << endl;
	}


	delete policko;
	delete [] typci;

	}

	return 0;
}
